//---------------------------------------------------------------------------
//
// "" for ʳβʳβ
// KawariInlineScript --  --
//
//      Programed by NAKAUE.T (Meister)
//
//  2001.05.14  Phase 0.50    First version
//  2001.05.19  Phase 5.1     
//  2001.06.17  Phase 6.0     ⤦
//  2001.08.08  Phase 6.2     ostrstreamХ
//  2002.07.10  Phase 8.1.0   %sɲ
//  2003.11.17  Phase 8.2.0   epocηвÿեޥåȽϲǽ
//
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include "kis/kis_date.h"
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <ctime>
#ifdef HAVE_SSTREAM
#include <sstream>
#else
#include <strstream>
#endif
#include <iomanip>
using namespace std;
//---------------------------------------------------------------------------
string KIS_date::Function(const vector<string>& args)
{
	time_t nowtt;
	if(args.size()>=3) {
		nowtt=(time_t)atoi(args[2].c_str());
	} else {
		nowtt=time(NULL);
	}
	struct tm *now=localtime(&nowtt);

	string format="%y/%m/%d %H:%M:%S";
	if(args.size()>=2) format=args[1];

#ifdef HAVE_SSTREAM
	ostringstream ret;
#else
	ostrstream ret;
#endif
	format+=' ';	// ߡ
	for(unsigned int i=0;i<(format.size()-1);i++) {
		if(format[i]=='%') {
			i++;
			switch(format[i]) {
			case 'd':	//  (01..31)
				ret << setw(2) << setfill('0') << now->tm_mday;
				break;
			case 'e':	//  (1..31)
				ret << now->tm_mday;
				break;
			case 'H':	//  (00..23)
				ret << setw(2) << setfill('0') << now->tm_hour;
				break;
			case 'j':	// ̻ (001..366)
				ret << setw(3) << setfill('0') << (now->tm_yday+1);
				break;
			case 'J':	// ̻ (1..366)
				ret << (now->tm_yday+1);
				break;
			case 'k':	//  (0..23)
				ret << now->tm_hour;
				break;
			case 'm':	//  (01..12)
				ret << setw(2) << setfill('0') << (now->tm_mon+1);
				break;
			case 'M':	// ʬ (00..59)
				ret << setw(2) << setfill('0') << now->tm_min;
				break;
			case 'n':	//  (1..12)
				ret << (now->tm_mon+1);
				break;
			case 'N':	// ʬ (0..59)
				ret << now->tm_min;
				break;
			case 'r':	//  (0..59)
				ret << now->tm_sec;
				break;
			case 'S':	//  (00..59)
				ret << setw(2) << setfill('0') << now->tm_sec;
				break;
			case 's':	// 1970/1/1 00:00:00 UTCÿ
				ret << nowtt;
				break;
			case 'w':	//  (0..6) 0
				ret << now->tm_wday;
				break;
			case 'y':	// ǯ (2000...) 4
			case 'Y':	// ǯ (2000...) 4
				ret << (now->tm_year+1900);
				break;
			case '%':
				ret << '%';
				break;
			default:
				ret << '%';
				i--;
			}
		} else {
			ret << format[i];
		}
	}

#ifdef HAVE_SSTREAM
	return string(ret.str());
#else
	ret << ends;
	string retstr(ret.str());
	ret.freeze(false);
	return(retstr);
#endif
}
//---------------------------------------------------------------------------

