//---------------------------------------------------------------------------
//
// "" for ʳβʳβ
//  2001.05.30  Phase 5.1     First version
//
//      Programed by NAKAUE.T (Meister)
//
//  2001.05.25  Phase 5.1     First version
//
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include "kis/kis_counter.h"
#include "libkawari/kawari_engine.h"
#include "libkawari/kawari_rc.h"
#include "misc/misc.h"
using namespace kawari::resource;
//---------------------------------------------------------------------------
#include <cstdlib>
using namespace std;
//---------------------------------------------------------------------------
string KIS_inc::Function_(const vector<string>& args,bool flag)
{
	if(!AssertArgument(args, 2, 4)) return("");

	int diff=1;
	if(args.size()>=3) {
		diff=atoi(args[2].c_str());
	}
	if(flag) diff=-diff;

	string entryname;
	int st,end;

	int range=TKawariEngine::DecodeEntryName(args[1],entryname,st,end);

	switch(range) {
	case 0:		// ϰϻ̵
		st=end=0;
		break;
	case 1:		// ñǻ
		break;
	case 2:		// ϰϻ
		// 顼
		GetLogger().GetStream(kawari_log::LOG_ERROR) << args[0] << RC.S(ERR_KIS_DICT_INVALID_INDEX) << endl;
		return("");
	}

	int counter=atoi(Engine->IndexParse(entryname,st).c_str())+diff;

	if(args.size()>=4) {
		int limit=atoi(args[3].c_str());
		if((counter>limit)&&!flag) counter=limit;
		if((counter<limit)&&flag)  counter=limit;
	}

	TEntry entry=Engine->CreateEntry(entryname);
	TWordID id=Engine->CreateStrWord(IntToString(counter));
	TWordID nullstr=Engine->CreateStrWord("");

	entry.Replace2(st,id,nullstr);

	return("");
}
//---------------------------------------------------------------------------

