//---------------------------------------------------------------------------
//
// "" for ʳβʳβ
// KawariInlineScript -- split --
//
//      Programed by ȡ/NAKAUE.T
//
//  2002.01.07  Phase 7.3     findpos֥ޥɲ (ȡ)
//                            splitޥɲ(ȡ)
//  2002.03.17  Phase 7.9.0   7.9λͤ˹碌 (NAKAUE.T)
//                            splitʤexprȤޤȤƤ뤫˶줷Τǰư
//                            splitѹ
//  2002.11.20  Phase 8.1.0   splitǤʤʤäƤХ
//                            joinɲ
//  2003.11.17  Phase 8.2.0   split̥ڤʸǤХ
//                            split,join:ڤʸάȥ̥ʸ
//
//---------------------------------------------------------------------------
#include "config.h"
//---------------------------------------------------------------------------
#include "kis/kis_split.h"
//---------------------------------------------------------------------------
#include <string>
using namespace std;
//---------------------------------------------------------------------------
#include "libkawari/kawari_engine.h"
#include "misc/l10n.h"
//---------------------------------------------------------------------------
class tokenizer {
private:

	string str;					// ڤФʸ
	string cs;					// ڤʸ
	string::size_type pos;		// ϳϰ
	string::size_type size;		// ڤФʸĹ

public:

	// ȡڤФ̤֤¤
	struct Parse {
		enum TParseState {
			parseOK,	// ȡڤФ
			parseEND	// ȡϤʾʤ
		} ParseState;
		
		string str;		// ڤФȡ
	};

	// ڤФʸ󡢶ڤʸν
	tokenizer(const string s, const string c);
	
	// ȡڤФ
	Parse token(void);
};
//---------------------------------------------------------------------------
tokenizer::tokenizer(const string s, const string c)
{
	str=s;
	cs=c;
	pos=0;
	size=ctow(s).length();
}
//---------------------------------------------------------------------------
tokenizer::Parse tokenizer::token(void)
{
	Parse ret;
	
	// ݥ󥿤ʸǸ褿
	if(pos>=size) {
		ret.ParseState=tokenizer::Parse::parseEND;
		ret.str="";
		return ret;
	}
	
	unsigned int idx;	// Υݥ
	if((idx=ctow(str).substr(pos,size-pos).find(ctow(cs)))!=string::npos) {
		// ڤʸ󤬥ݥ󥿰ʹߤʸˤä
		ret.ParseState=tokenizer::Parse::parseOK;
		ret.str=wtoc(ctow(str).substr(pos,idx));	// ʸ֤뤳Ȥ⤢
		pos+=idx+ctow(cs).length();				// ڤʸʬݥ
	} else {
		// ڤʸ󤬥ݥ󥿰ʹߤʸˤʤ
		ret.ParseState=tokenizer::Parse::parseOK;
		ret.str=wtoc(ctow(str).substr(pos,size-pos));	// ʸ֤뤳Ȥ⤢
		pos=size;									// ݥ󥿤ʸǸ
	}
	
	return ret;
}
//---------------------------------------------------------------------------
string KIS_split::Function(const vector<string>& args){

	if(!AssertArgument(args, 3, 4)) return ("");

	TEntry entry=Engine->CreateEntry(args[1]);
	if(args[3]=="" || args.size()==3) {
		for(unsigned int idx=0;idx<ctow(args[2]).length();idx++) {
			entry.Push(Engine->CreateStrWord(wtoc(ctow(args[2]).substr(idx,1))));
		}
		return("");
	}

	tokenizer sentence(args[2],args[3]);
	tokenizer::Parse result=sentence.token();
	while(result.ParseState==tokenizer::Parse::parseOK) {
		entry.Push(Engine->CreateStrWord(result.str));
		result=sentence.token();
	}

	return("");
}
//---------------------------------------------------------------------------
string KIS_join::Function(const vector<string>& args)
{
	if(!AssertArgument(args, 2, 3)) return ("");

	TEntry entry=Engine->GetEntry(args[1]);
	unsigned int size=entry.Size();

	string retstr;
	string sep;
	if(args.size()==2) {
		sep="";
	} else {
		sep=args[2];
	}
	for(unsigned int i=0;i<size;i++) {
		retstr+=Engine->IndexParse(entry,i)+sep;
	}

	return(retstr.substr(0,retstr.length()-sep.length()));
}
//---------------------------------------------------------------------------
